#!-------------------------------------------------------------------------
#! iaDct2Queue.tpl (c) 2006 by iAlchemy, Ltd. All rights reserved.
#!      
#!      Version:  1.00
#!         Date:  2006May03
#!      
#!-------------------------------------------------------------------------
#Template(Dct2Queue,'Dictionary Tables'),Family('Clarion', 'CW20','ABC')
#!=========================================================================
#EXTENSION(Dct2Queue,'[iAlchemy] Export DCT Tables to Queue'),PROCEDURE
#!-------------------------------------------------------------------------
#DISPLAY('')
#DISPLAY(' Dct2Queue [iAlchemy, Ltd.] '),AT(3,0,194,12), PROP(PROP:FontColor, 0FFFFFFH), PROP(PROP:Color,0848C52H), PROP(PROP:FontSize,11), PROP(PROP:Font,'Verdana'), PROP(PROP:FontStyle,700)
#SHEET,ADJUST
  #TAB(' Eligible Tables')
    #DISPLAY('')
#!    #BUTTON('Include'),MULTI(%ixTables, %ixFile),INLINE
    #BUTTON('Include'),MULTI(%ixTables, CALL(%ixGetFileInfo,%ixFile)),INLINE
      #PREPARE
        #DECLARE(%appTables),UNIQUE
        #FOR(%File), WHERE(%FileType = 'FILE')
          #ADD(%appTables, %File)
        #ENDFOR
      #ENDPREPARE
      #PROMPT('Table: ',FROM(%appTables)),%ixFile
#!      #PROMPT('SysId: ',FIELD(%ixFile)),%ixIdentityField
    #ENDBUTTON
    #BUTTON('Add all tables'), WHENACCEPTED(%ixAddAllTables())
    #ENDBUTTON
  #ENDTAB
  #TAB(' Help ')
    #DISPLAY('')
    #DISPLAY('Tables declared in the DCT are exported to...')
    #DISPLAY('')
    #DISPLAY('DctFileQ queue,pre(DctFileQ)')
    #DISPLAY('')
    #DISPLAY('   Name       cstring(41)')
    #DISPLAY('   TableRef   &&File')
    #DISPLAY('   RecordRef  &&Group')
    #DISPLAY('')
  #ENDTAB
#ENDSHEET
#!-------------------------------------------------------------------------
#AT(%DataSection,%ActiveTemplateInstance),PRIORITY(10),DESCRIPTION('{ Dct2Queue.Declarations }')
!{ begin }
DctFileQ    queue,pre(DctFileQ)
Name            cstring(41)
Records         long
TableRef        &file
RecordRef       &group
            end
!{ end }
#ENDAT
#!--------------------------
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(9990),DESCRIPTION('{ Dct2Queue.Init }')
    do Load::DctQ
#ENDAT
#!--------------------------
#AT(%ProcessedCode,%ActiveTemplateInstance),PRIORITY(1000),DESCRIPTION('{ Dct2Queue.Init }')
    do Load::DctQ
#ENDAT
#!--------------------------
#AT(%ProcedureRoutines,%ActiveTemplateInstance),PRIORITY(100),DESCRIPTION('{ Dct2Queue.Routine }')
Load::DctQ Routine

    free(DctFileQ)
  #FOR(%ixTables)
    #CALL(%pAddFileQ)
  #ENDFOR
#ENDAT
#!--------------------------
#AT(%LocalDataAfterClasses,%ActiveTemplateInstance),PRIORITY(100),DESCRIPTION('{ Dct2Queue.LocalMap }')
    map
  #IF(%AppTemplateFamily='ABC')
        _RowCount(FileManager pFile), long
  #ELSE
        _RowCount(File pFile), long
  #ENDIF
    end
#ENDAT
#!--------------------------
#AT(%LocalProcedures,%ActiveTemplateInstance),PRIORITY(100),DESCRIPTION('{ Dct2Queue.Procedures }'), WHERE(%AppTemplateFamily <> 'ABC')
_RowCount procedure(File pFile)
RC              long

    code

    open(pFile)
    RC = records(pFile)
    close(pFile)

    return RC
#ENDAT
#!--------------------------
#AT(%LocalProcedures,%ActiveTemplateInstance),PRIORITY(100),DESCRIPTION('{ Dct2Queue.Procedures }'), WHERE(%AppTemplateFamily = 'ABC')
_RowCount procedure(FileManager pFile)
lazy            byte, auto
RC              long

    code

    lazy = pFile.LazyOpen ! save mode
    pFile.LazyOpen = false
    if pFile.TryOpen() <> Level:Benign
      pFile.LazyOpen = lazy ! restore mode
      return -1 ! invslid file
    end

    pFile.LazyOpen = lazy ! restore mode
    
    IF pFile.UseFile() = Level:Benign
      RC = records(pFile.File)
      pFile.close()
    END
    
    return RC
#ENDAT
#!--------------------------
#GROUP(%pAddFileQ)
  !- include %ixFile...
    clear(DctFileQ)
    DctFileQ.Name        = '%ixFile'
    #IF(%AppTemplateFamily = 'ABC')
    DctFileQ.Records     = _RowCount(Access:%ixFile)
    #ELSE
    DctFileQ.Records     = _RowCount(%ixFile)
    #ENDIF
    DctFileQ.TableRef   &= %ixFile
    DctFileQ.RecordRef  &= %ixFile:Record
    
    if DctFileQ.Records <> -1 ! file not available
      add(DctFileQ)
    end
#!-------------------------------------------------------------------------
#GROUP(%ixAddAllTables)
  #FREE(%ixTables)
  #FOR(%File), WHERE(%FileType = 'FILE')
    #ADD(%ixTables, ITEMS(%ixTables) + 1)
    #SET(%ixFile, %File)
  #ENDFOR    
#!-------------------------------------------------------------------------
#GROUP(%ixGetFileInfo, %pFile)
  #FIX(%File, %pFile)
  #RETURN(%File & ' (' & UPPER(%FileDriver) & ')')